> For the complete documentation index, see [llms.txt](https://docs.2checkout.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.2checkout.com/shopping-carts/inline/use-cases/subscribe-unsubscribe-to-shopping-cart-events-for-inline-checkout.md).

# Subscribe / unsubscribe to shopping cart events for InLine Checkout

## Overview

Subscribe and unsubscribe to Inline checkout events.

## Use case

1. Add an HTML link or button in your page like the one below.
2. Create a JavaScript click handler to execute the Inline Client desired methods.
3. Use the `TwoCoInlineCart.products.add({code, quantity, options})` method to prepare your catalog product.
4. In order to subscribe to an event use:<br>

   ```javascript
   TwoCoInlineCart.events.subscribe('cart:opened', function () {
       alert('Cart was opened.');
   });
   ```
5. In order to unsubscribe from an event use the Handler GUID that you can obtain when subscribing to the event.<br>

   ```javascript
   let cartClosedhandlerGuid = TwoCoInlineCart.events.subscribe('cart:closed', function () {
       alert('Cart was closed.');
   });
   TwoCoInlineCart.events.unsubscribe('cart:closed', cartClosedhandlerGuid);
   ```
6. Use the `TwoCoInlineCart.cart.checkout()` method to show the cart on your page.

## Sample request

### HTML

```html
<a href="#" class="btn btn-success" id="buy-button">Buy now!</a>
```

### JavaScript

```javascript
window.addEventListener('load', function() {
    TwoCoInlineCart.events.subscribe('cart:opened', function () {
      alert('Cart was opened.');
    });
    
    TwoCoInlineCart.events.subscribe('payment:finalized', function () {
      alert('Payment was finalized.');
    });
    
    TwoCoInlineCart.events.subscribe('fulfillment:finalized', function () {
      alert('Fulfillment was finalized.');
    });
    
    var cartClosedhandlerGuid = TwoCoInlineCart.events.subscribe('cart:closed', function () {
      alert('Cart was closed.');
    });
    TwoCoInlineCart.events.unsubscribe('cart:closed', cartClosedhandlerGuid);

    TwoCoInlineCart.events.subscribe('cart:error', function (errorData) {
      console.log('Cart error occurred:', errorData);
      // errorData will now contain the error object with the errors array
      if (errorData && errorData.errors && errorData.errors.length > 0) {
          const error = errorData.errors[0];

          if (error.code === 'GDPR_EMAIL_VALIDATION') {
              console.log('GDPR validation failed:', error.message);
              alert('Please verify your email address');
          } else if (error.code === 'BOOT_ERROR') {
              console.log('Boot error:', error.message);
              alert('Unable to initialize cart');
          }
      }
    });
  });

  window.document.getElementById('buy-button').addEventListener('click', function() {
    TwoCoInlineCart.products.add({
      code: "74B8E17CC0"
    });
    TwoCoInlineCart.cart.checkout();
  });
```

## Demo

After setting the subscribe/unsubscribe details for the InLine cart using the above methods, your cart should look like this:

{% embed url="<https://codepen.io/2checkout-documentation/pen/EByzpY>" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.2checkout.com/shopping-carts/inline/use-cases/subscribe-unsubscribe-to-shopping-cart-events-for-inline-checkout.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
